
/**
 * Provides a Stack object for storing ints
 * 
 * @author Philip Howard 
 * @version Option A
 */
public class StackA
{
    // instance variables
    private static final int MAX_SIZE = 4;
    private int size;
    private int data[];

    /**
     * Creates a new, empty Stack object. This stack can hold 4 numbers.
     */
    public StackA()
    {
        // initialise instance variables
        size = 0;
        data = new int[MAX_SIZE+1];
        for (int ii=0; ii<MAX_SIZE; ii++)
        {
            data[ii] = 0;
        }
    }
    
    /**
     * push an int onto the stack
     * 
     * @param  val value to be pushed onto the stack
     */
    public void push(int val)
    {
        if (!isFull())
        {
            data[size] = val;
            size++;
        }
    }

    /**
     * pop a value of the stack
     * 
     * @return     the value popped off the stack
     */
    public int pop()
    {
        int value = 0;
        if (!isEmpty())
        {
            value = data[size];
            size--;
            if (size < 0) size = 0;
        }
        return value;
    }

    /**
     * returns true if the stack is Empty
     * 
     * @return     true if the stack is Empty
     */
    public boolean isEmpty()
    {
        if (size==0)
            return true;
        else
            return false;
    }

    /**
     * returns true if the stack is Full
     * 
     * @return     true if the stack is Full
     */
    public boolean isFull()
    {
        if (size==MAX_SIZE)
            return true;
        else
            return false;
    }
}
