
/**
 * Provides a Stack object for storing ints
 * 
 * @author Philip Howard 
 * @version Option C
 */
public class StackC
{
    // instance variables
    private static final int MAX_SIZE = 4;
    private int size;
    private int data[];

    /**
     * Creates a new, empty Stack object. This stack can hold 4 numbers.
     */
    public StackC()
    {
        // initialise instance variables
        size = 0;
        data = new int[MAX_SIZE];
        for (int ii=0; ii<MAX_SIZE; ii++)
        {
            data[ii] = 0;
        }
    }
    
    /**
     * Pushes the given number onto the stack
     * 
     * @param  num The numbers to be pushed onto the stack
     */
    public void push(int num)
    {
        if (!isFull())
        {
            data[size] = num;
            size++;
        }
    }

    /**
     * Pops the top number off the stack. This removes the number from the stack and returns it.
     * 
     * @return The number popped off the stack
     */
    public int pop()
    {
        int value = 0;
        if (!isEmpty())
        {
            size--;
            value = data[size];
        }
        return value;
    }

    /**
     * Returns whether the Stack is empty or not.
     * 
     * @return     True if the stack is empty, false otherwise
     */
    public boolean isEmpty()
    {
        if (size==0)
            return true;
        else
            return false;
    }

    /**
     * Returns whether the Stack is full or not. Note the stack can hold 4 items.
     * 
     * @return     True if the stack is full, false otherwise.
     */
    public boolean isFull()
    {
        if (size==MAX_SIZE)
            return true;
        else
            return false;
    }
}
